<?php

global $sgbb;
$sgbb->includeModel('Model');

class SGBB_ThemeModel extends SGBB_Model
{
	const TABLE = 'theme';
	protected $id;
	protected $title;
	protected $bb_css;

	public static function finder($class = __CLASS__)
	{
		return parent::finder($class);
	}

	public static function create()
	{
		global $sgbb;
		global $wpdb;
		$tablename = $sgbb->tablename(self::TABLE);

		$query = "CREATE TABLE IF NOT EXISTS $tablename (
			  `id` int(10) NOT NULL AUTO_INCREMENT,
			  `title` varchar(255) NOT NULL,
			  `bb_css` longtext NOT NULL,
			  PRIMARY KEY (`id`)
			) ENGINE=InnoDB DEFAULT CHARSET=utf8;";
		$wpdb->query($query);

		$wpdb->query('DELETE FROM '.$tablename);

		$insertQuery = "INSERT INTO $tablename (`id`, `title`, `bb_css`) VALUES (1, 'theme_1', '.sgbb-theme-type-1 .sgbb-main-wrapper {\n	display: inline-block;\n	overflow: hidden;\n	border-radius: 5px;\n	counter-reset: flag; \n}\n.sgbb-theme-type-1 .sgbb-main-wrapper li a {\n	text-decoration: none;\n	outline: none;\n	display: block;\n	float: left;\n	font-size: 12px;\n	line-height: 36px;\n	color: white;\n	padding: 0 10px 0 60px;\n	background-color: #444;\n	position: relative;\n}\n.sgbb-theme-type-1 .sgbb-main-wrapper li:first-child a {\n	padding-left: 46px;\n	border-radius: 5px 0 0 5px;\n}\n.sgbb-theme-type-1 .sgbb-main-wrapper li:first-child a:before {\n	left: 14px;\n}\n.sgbb-theme-type-1 .sgbb-main-wrapper li:last-child a {\n	border-radius: 0 5px 5px 0;\n	padding-right: 20px;\n	background-color: #101010;\n}\n.sgbb-theme-type-1 .sgbb-main-wrapper li a:focus, \n.sgbb-theme-type-1 .sgbb-main-wrapper li a:active, \n.sgbb-theme-type-1 .sgbb-main-wrapper li a:hover { \n	background-color: #101010;\n}\n.sgbb-theme-type-1 .sgbb-main-wrapper li a:focus:after,\n.sgbb-theme-type-1 .sgbb-main-wrapper li a:active:after,\n.sgbb-theme-type-1 .sgbb-main-wrapper li a:hover:after {\n	background-color: #101010;\n}\n.sgbb-theme-type-1 .sgbb-main-wrapper li a:after {\n	content: '''';\n	position: absolute;\n	top: 0; \n	right: -18px;\n	width: 36px; \n	height: 36px;\n	transform: scale(0.707) rotate(45deg);\n	z-index: 1;\n	background-color: #444;\n	box-shadow: \n		2px -2px 0 2px rgba(0, 0, 0, 0.4), \n		3px -3px 0 2px rgba(255, 255, 255, 0.1);\n	border-radius: 0 5px 0 50px;\n}\n.sgbb-theme-type-1 .sgbb-main-wrapper li:last-child a:after {\n	content: none;\n	background-color: #101010;\n}\n.sgbb-theme-type-1 .sgbb-main-wrapper li:last-child a:before {\n	background-color: #444;\n}\n.sgbb-theme-type-1 .sgbb-main-wrapper li a:hover:before,\n.sgbb-theme-type-1 .sgbb-main-wrapper li a:focus:before,\n.sgbb-theme-type-1 .sgbb-main-wrapper li a:active:before {\n	background-color:#444;\n}\n.sgbb-theme-type-1 .sgbb-main-wrapper li a:before {\n	content: counter(flag);\n	counter-increment: flag;\n	border-radius: 100%;\n	width: 20px;\n	height: 20px;\n	line-height: 20px;\n	margin: 8px 0;\n	position: absolute;\n	top: 0;\n	left: 30px;\n	background-color: #101010;\n	font-weight: bold;\n}\n')";
		$insertQuery2 = "INSERT INTO $tablename (`id`, `title`, `bb_css`) VALUES (2, 'theme_2', '.sgbb-theme-type-2 .sgbb-main-wrapper li {\n	float: left;\n}\n.sgbb-theme-type-2 .sgbb-main-wrapper {\n	display: inline-block;\n	overflow: hidden;\n	border-radius: 5px;\n}\n.sgbb-theme-type-2 .sgbb-main-wrapper li a {\n	outline: none;\n	display: block;\n	float: left;\n	font-size: 12px;\n	line-height: 36px;\n	background-color: #fff;\n	position: relative;\n	color: #333;\n	text-decoration: none;\n	max-width: 170px;\n	padding:6px 12px 6px 24px;\n	box-shadow: none;\n}\n.sgbb-theme-type-2 .sgbb-main-wrapper li:not(:first-child) a {\n	padding: 0 10px 0 35px;\n}\n.sgbb-theme-type-2 .sgbb-main-wrapper li:first-child a {\n	padding: 0 10px 0 20px;\n}\n.sgbb-theme-type-2 .sgbb-main-wrapper li:first-child a:before {\n	left: 14px;\n}\n.sgbb-theme-type-2 .sgbb-main-wrapper li:last-child a {\n	padding-right: 20px;\n	background-color: #adadad;\n}\n.sgbb-theme-type-2 .sgbb-main-wrapper li a:focus, \n.sgbb-theme-type-2 .sgbb-main-wrapper li a:active, \n.sgbb-theme-type-2 .sgbb-main-wrapper li a:hover { \n	background-color: #adadad;\n}\n.sgbb-theme-type-2 .sgbb-main-wrapper li a:focus:after,\n.sgbb-theme-type-2 .sgbb-main-wrapper li a:active:after,\n.sgbb-theme-type-2 .sgbb-main-wrapper li a:hover:after {\n	background-color: #adadad;\n	box-shadow: 2px -2px 0 1px #d1d1d1;\n}\n.sgbb-theme-type-2 .sgbb-main-wrapper li a:after {\n	content: '''';\n	position: absolute;\n	top: 0; \n	right: -18px;\n	width: 36px; \n	height: 36px;\n	transform: scale(0.707) rotate(45deg);\n	z-index: 1;\n	background-color: #fff;\n	box-shadow: 2px -2px 0 1px #adadad;\n	border-radius: 0 5px 0 50px;\n}\n.sgbb-theme-type-2 .sgbb-main-wrapper li a:hover {\n	color: #333;\n	background-color: #adadad;\n}\n.sgbb-theme-type-2 .sgbb-main-wrapper li:last-child a:after {\n	content: none;\n}\n.sgbb-theme-type-2 .sgbb-main-wrapper li:last-child a:before {\n	background-color: #fff;\n}')";
		$insertQuery3 = "INSERT INTO $tablename (`id`, `title`, `bb_css`) VALUES (3, 'theme_3', '.sgbb-theme-type-3 .sgbb-main-wrapper {\n	display: inline-block;\n	overflow: hidden;\n	border-radius: 5px;\n}\n.sgbb-theme-type-3 .sgbb-main-wrapper a {\n	text-decoration: none;\n	display: block;\n	float: left;\n	font-size: 14px;\n	line-height: 36px;\n	padding: 0 20px;\n	background-color: #e7e7e7;\n	position: relative;\n}\n.sgbb-theme-type-3 .sgbb-separator {\n	color: #c1c1c1;\n	font-size: 14px;\n	float: left;\n	display:block;\n	background-color:#e7e7e7;\n	line-height: 36px;\n}\n.sgbb-theme-type-3 .sgbb-main-wrapper a:hover,\n.sgbb-theme-type-3 .sgbb-main-wrapper a:focus,\n.sgbb-theme-type-3 .sgbb-main-wrapper a:active {\n	background-color: #c7c7c7;\n}\n.sgbb-theme-type-3 .sgbb-main-wrapper li:last-child a {\n	background-color: #c7c7c7;\n}')";
		$insertQuery4 = "INSERT INTO $tablename (`id`, `title`, `bb_css`) VALUES (4, 'theme_4', '.sgbb-theme-type-4 .sgbb-main-wrapper {\n	display: inline-block;\n	overflow: hidden;\n	border-radius: 5px;\n}\n.sgbb-theme-type-4 .sgbb-main-wrapper li a {\n	text-decoration: none;\n	display: block;\n	float: left;\n	color: #ffffff;\n	font-size: 14px;\n	font-weight: bold;\n	line-height: 36px;\n	padding: 0 20px;\n	background-color: hsla(34, 85%, 65%, 1);\n	position: relative;\n}\n.sgbb-theme-type-4 .sgbb-main-wrapper li:not(:last-child) a {\n	border-right: 1px solid #ffffff;\n}\n.sgbb-theme-type-4 .sgbb-main-wrapper li a:hover,\n.sgbb-theme-type-4 .sgbb-main-wrapper li a:focus,\n.sgbb-theme-type-4 .sgbb-main-wrapper li a:active,\n.sgbb-theme-type-4 .sgbb-main-wrapper li:last-child a {\n	background-color: #754609;\n}')";
		$insertQuery5 = "INSERT INTO $tablename (`id`, `title`, `bb_css`) VALUES (5, 'theme_5', '.sgbb-theme-type-5 .sgbb-main-wrapper li a {\n	background-color: #ffffff;\n	display: block;\n	float: left;\n	font-size: 14px;\n	line-height: 36px;\n	position: relative;\n	text-decoration: none;\n}\n.sgbb-theme-type-5 .sgbb-main-wrapper li:last-child a {\n	padding-right: 20px;\n}\n.sgbb-theme-type-5 .sgbb-main-wrapper li:first-child a {\n	padding-left: 20px;\n}\n.sgbb-theme-type-5 .sgbb-main-wrapper {\n	display: inline-block;\n	overflow: hidden;\n	border-radius: 5px;\n}\n.sgbb-theme-type-5 .sgbb-you-here {\n	background-color: #ffffff;\n	display: block;\n	float: left;\n	font-size: 14px;\n	line-height: 36px;\n	position: relative;\n	text-decoration: none;\n}\n\n.sgbb-theme-type-5 .sgbb-separator {\n	background-color: #ffffff;\n	display: block;\n	float: left;\n	font-size: 14px;\n	line-height: 36px;\n	padding: 0 20px;\n	position: relative;\n	text-decoration: none;\n}')";
		$insertQuery6 = "INSERT INTO $tablename (`id`, `title`, `bb_css`) VALUES (6, 'theme_6', '.sgbb-theme-type-6 .sgbb-ul-list-wrapper {\n	list-style: none;\n	overflow: hidden;\n	font: 14px Helvetica, Arial, Sans-Serif;\n	margin: 0;\n	padding: 0;\n	display: inline-block;\n	background-color: #ccc;\n	max-height: 35px !important;\n		}\n		.sgbb-theme-type-6 .sgbb-ul-list-wrapper li { \n	float: left; \n		}\n		.sgbb-theme-type-6 .sgbb-ul-list-wrapper li a {\n	color: white;\n	text-decoration: none; \n	padding: 10px 10px 10px 40px;\n	background-color: #9c9c9c; \n	position: relative; \n	display: block;\n	float: left;\n		}\n		.sgbb-theme-type-6 .sgbb-ul-list-wrapper li a:after { \n	content: \" \";	\n	display: block;	\n	width: 0;	\n	height: 0;	\n	border-bottom: 70px solid transparent;\n	border-left: 24px solid #9c9c9c;\n	position: absolute;\n	top: 50%;\n	margin-top: -50px; \n	left: 100%;\n	z-index: 2; \n		}	\n		.sgbb-theme-type-6 .sgbb-ul-list-wrapper li a:before {\n	content: \" \"; \n	display: block; \n	width: 0;	\n	height: 0;	\n	border-top: 70px solid transparent;\n	border-bottom: 47px solid transparent;\n	border-left: 30px solid #ccc;\n	position: absolute;\n	top: 50%;\n	margin-top: -50px; \n	margin-left: 1px;\n	left: 100%;\n	z-index: 1; \n		}\n		.sgbb-theme-type-6 .sgbb-ul-list-wrapper li:first-child a {\n	padding-left: 10px;\n		}\n		.sgbb-theme-type-6 .sgbb-ul-list-wrapper li a:hover { background-color: #ccc; }\n		.sgbb-theme-type-6 .sgbb-ul-list-wrapper li a:hover:after { border-left-color: #ccc; }\n		.sgbb-theme-type-6 .sgbb-ul-list-wrapper .sgbb-home-link {\n	padding-top:5px !important;\n		}\n')";
		$insertQuery7 = "INSERT INTO $tablename (`id`, `title`, `bb_css`) VALUES (7, 'theme_7', '.sgbb-theme-type-7 ul { \n	list-style: none;\n	overflow: hidden;\n	font: 14px Helvetica, Arial, Sans-Serif;\n	margin: 0;\n	padding: 0;\n	display: inline-block;\n	background-color: rgb(130,170,50);\n                        max-height: 35px !important;\n		}\n		.sgbb-theme-type-7 ul li { \n	float: left; \n		}\n		.sgbb-theme-type-7 ul li a {\n	color: white;\n	text-decoration: none; \n	padding: 10px 10px 10px 40px;\n	background-color: rgb(66,66,66); \n	position: relative; \n	display: block;\n	float: left;\n		}\n		.sgbb-theme-type-7 ul li a:after { \n	content: \" \"; \n	display: block; \n	width: 0; \n	height: 0;\n	border-top: 70px solid transparent;\n	border-bottom: 70px solid transparent;\n	border-left: 25px solid rgb(66,66,66);\n	position: absolute;\n	top: 50%;\n	margin-top: -50px; \n	left: 100%;\n	z-index: 2; \n		}	\n		.sgbb-theme-type-7 ul li a:before { \n	content: \" \"; \n	display: block; \n	width: 0; \n	height: 0;\n	border-top: 70px solid transparent;\n	border-bottom: 47px solid transparent;\n	border-left: 25px solid white;\n	position: absolute;\n	top: 50%;\n	margin-top: -50px; \n	margin-left: 3px;\n	left: 100%;\n	z-index: 1; \n		}\n		.sgbb-theme-type-7 ul li:first-child a  {\n	padding-left: 20px;\n		}\n		.sgbb-theme-type-7 ul li:last-child a {\n	padding-right: 20px;\n		}\n		.sgbb-theme-type-7 ul li:last-child a,\n		.sgbb-theme-type-7 .sgbb-ul-list-wrapper li a:hover {\n	background-color: rgb(130,170,50);\n		}\n		.sgbb-theme-type-7 ul li a:hover:after {\n	border-left-color: rgb(130,170,50);\n		}\n		')";
		$insertQuery8 = "INSERT INTO $tablename (`id`, `title`, `bb_css`) VALUES (8, 'theme_8', '.sgbb-theme-type-8 .sgbb-main-wrapper {\n	display: inline-block;\n	overflow: hidden;\n	border-radius: 5px;\n	}\n	.sgbb-theme-type-8 .sgbb-main-wrapper ul {\n	list-style: none;\n	margin: 0;\n	padding: 0;\n	}\n.sgbb-theme-type-8 .sgbb-main-wrapper li {\n	float: left;\n		}\n		.sgbb-theme-type-8 .sgbb-main-wrapper ul li a {\n			text-decoration: none;\n			display: block;\n			float: left;\n			color: #ffffff;\n			font-size: 14px;\n			font-weight: bold;\n			line-height: 36px;\n			padding: 0 20px;\n			background-color: rgb(40,145,245);\n			position: relative;\n			border-top-right-radius: 50px;\n			border-top-left-radius: 50px;\n		}\n		.sgbb-theme-type-8 .sgbb-main-wrapper ul li:not(:last-child) a {\n			border-right: 1px solid #ffffff;\n		}\n		.sgbb-theme-type-8 .sgbb-main-wrapper ul li a:hover,\n		.sgbb-theme-type-8 .sgbb-main-wrapper ul li a:focus,\n		.sgbb-theme-type-8 .sgbb-main-wrapper ul li a:active,\n		.sgbb-theme-type-8 .sgbb-main-wrapper ul li:last-child a {\n			background-color: rgb(20,100,235);\n		}')";
		$insertQuery9 = "INSERT INTO $tablename (`id`, `title`, `bb_css`) VALUES (9, 'theme_9', '.sgbb-theme-type-9 .sgbb-main-wrapper {\n			display: inline-block;\n			overflow: hidden;\n			border-radius: 5px;\n		}\n		.sgbb-theme-type-9 .sgbb-main-wrapper ul {\n			list-style: none;\n			margin: 0;\n			padding: 0;\n		}\n		.sgbb-theme-type-9 .sgbb-main-wrapper li {\n			float: left;\n		}\n		.sgbb-theme-type-9 .sgbb-main-wrapper ul li a {\n			text-decoration: none;\n			display: block;\n			float: left;\n			color: #ffffff;\n			font-size: 14px;\n			font-weight: bold;\n			line-height: 36px;\n			padding: 0 20px;\n			background-color: rgb(231, 229, 39);\n			position: relative;\n			border-top-right-radius: 50px;\n			border-bottom-left-radius: 50px;\n		}\n		.sgbb-theme-type-9 .sgbb-main-wrapper ul li:not(:last-child) a {\n			border-right: 1px solid #ffffff;\n		}\n		.sgbb-theme-type-9 .sgbb-main-wrapper ul li a:hover,\n		.sgbb-theme-type-9 .sgbb-main-wrapper ul li a:focus,\n		.sgbb-theme-type-9 .sgbb-main-wrapper ul li a:active,\n		.sgbb-theme-type-9 .sgbb-main-wrapper ul li:last-child a {\n			background-color: rgb(231, 175, 39);\n		}')";
		$insertQuery10 = "INSERT INTO $tablename (`id`, `title`, `bb_css`) VALUES (10, 'theme_10', '.sgbb-theme-type-10 .sgbb-main-wrapper {\n			display: inline-block;\n			overflow: hidden;\n			border-radius: 5px;\n		}\n		.sgbb-theme-type-10 .sgbb-main-wrapper ul {\n			list-style: none;\n			margin: 0;\n			padding: 0;\n		}\n		.sgbb-theme-type-10 .sgbb-main-wrapper li {\n			float: left;\n		}\n		.sgbb-theme-type-10 .sgbb-main-wrapper ul li a {\n			text-decoration: none;\n			display: block;\n			float: left;\n			color: #ffffff;\n			font-size: 14px;\n			font-weight: bold;\n			line-height: 36px;\n			padding: 0 20px;\n			background-color: rgb(26, 92, 187);\n			position: relative;\n		}\n		.sgbb-theme-type-10 .sgbb-main-wrapper ul li:not(:last-child) a:after {\n			content: '''';\n			position: absolute;\n			top: 0; \n			right: -18px;\n			width: 36px; \n			height: 36px;\n			transform: scale(0.707) rotate(45deg);\n			z-index: 1;\n			background-color: rgb(26, 92, 187);\n			border-top-right-radius: 50px;\n			box-shadow: 2px -2px 0 1px white;\n		}\n		.sgbb-theme-type-10 .sgbb-main-wrapper ul li:not(:last-child) a {\n			border-right: 1px solid #ffffff;\n		}\n		.sgbb-theme-type-10 .sgbb-main-wrapper ul li a:hover,\n		.sgbb-theme-type-10 .sgbb-main-wrapper ul li a:hover:after,\n		.sgbb-theme-type-10 .sgbb-main-wrapper ul li a:focus,\n		.sgbb-theme-type-10 .sgbb-main-wrapper ul li a:focus:after,\n		.sgbb-theme-type-10 .sgbb-main-wrapper ul li a:active,\n		.sgbb-theme-type-10 .sgbb-main-wrapper ul li a:active:after,\n		.sgbb-theme-type-10 .sgbb-main-wrapper ul li:last-child a {\n			background-color: rgb(47, 160, 204);\n		}')";

		$wpdb->query($insertQuery);
		$wpdb->query($insertQuery2);
		$wpdb->query($insertQuery3);
		$wpdb->query($insertQuery4);
		$wpdb->query($insertQuery5);
		$wpdb->query($insertQuery6);
		$wpdb->query($insertQuery7);
		$wpdb->query($insertQuery8);
		$wpdb->query($insertQuery9);
		$wpdb->query($insertQuery10);
	}

	public static function drop()
	{
		global $sgbb;
		global $wpdb;
		$tablename = $sgbb->tablename(self::TABLE);
		$query = "DROP TABLE $tablename";
		$wpdb->query($query);
	}
}
